Name: libc5
Summary: standard shared libraries for programs
%define version 5.4.38
%define mversion 5.0.9
Version: %{version}
Release: 3
ExclusiveArch: i386 sparc
ExclusiveOS: Linux
Copyright: distributable
Group: Libraries
Source: sunsite.unc.edu:/pub/Linux/GCC/libc-%{version}.tar.gz
Patch0: libc5-%{version}-config.patch
Patch1: libc5-%{version}-locale.patch
Patch2: libc5-%{version}-wchar.patch
Patch3: libc5-%{version}-makeconfig.patch
#Patch4: libc5-%{version}-include.patch
BuildRoot: /var/tmp/libc5-build
Provides: libc5

%package devel
Summary: Additional libraries required to compile
Group: Development/Libraries/Libc
Requires: kernel-headers binutils
%package static
Summary: Libraries for static linking
Group: Development/Libraries/Libc
Requires: binutils
%package profile
Summary: libc with profiling support
Group: Development/Libraries/Libc
Requires: binutils
%package debug
Summary: libc with debugging information
Group: Development/Libraries/Libc
Requires: binutils

%description
Contains the standard libraries that are used by multiple programs on
the system. In order to save disk space and memory, as well as to 
ease upgrades, common system code is kept in one place and shared between
programs. This package contains the most important sets of shared libraries,
the standard C library and the standard math library. Without these, a 
Linux system will not function.

%description devel
To develop programs which use the standard C libraries (which nearly all
programs do), the system needs to have these standard header files and object
files available for creating the executables.

%description static
While most programs are distributed dynamically linked, and therefore need
access to the standard shared libraries, some developers prefer to
ship programs statically linked, which includes all of the standard library
code in the executable. While this results in significantly larger 
programs and increases their memory usage, it does increase the portability
of programs between Linux systems.

%description profile
When programs are being profiled used gprof, they must use these libraries
instrad of the standard C libraries for gprof to be able to profile
them correctly.

%description debug
These libraries have the debugging information debuggers use for tracing
the execution of programs. These are only needed when the shared libraries
themselves are being debugged -- they are not needed to debug programs which
use them. 

#%package locale
#Summary: Tools for manipulation locale definition files for other languages
#Group: Utilities/Text
#%description locale
#This package includes the tools necessary to generate and manipulate the
#locale definition files that libc uses to provide multi-lingual support.

%prep
%setup -c -q

%patch0 -p1 -b .cfg
%patch1 -p0 
%patch2 -p1 -b .wc
#%patch4 -p1 -b .inc

cd include
# Assumes that the kernel sources are in their standard places...
ln -s /usr/src/linux/include/linux .
ln -s /usr/src/linux/include/asm .

cd ../libc
mv config.in config.in.tmpl
sed "s&REPLACEMEWITHTARGET&$RPM_BUILD_ROOT/&" < config.in.tmpl > config.in

cd ..
%patch3 -p1 -b .mkcfg

%build

cd libc

./configure <<EOF

EOF
make
#make -C locale locale localedef

%install

if [ "X$RPM_BUILD_ROOT" != "X" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

mkdir -p $RPM_BUILD_ROOT/etc
mkdir -p $RPM_BUILD_ROOT/lib
mkdir -p $RPM_BUILD_ROOT/usr/i486-linuxlibc5/{bin,lib,include}

rm -f include/*.inc include/*.mkcfg include/*.wc
tar cvSpf - include | (cd $RPM_BUILD_ROOT/usr/i486-linuxlibc5; tar xSpf -)

# this comes from the linuxthreads package
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/pthread.h

#install -m755 -s libc/locale/locale $RPM_BUILD_ROOT/usr/i486-linuxlibc5/bin/locale
#install -m755 -s libc/locale/localedef $RPM_BUILD_ROOT/usr/i486-linuxlibc5/bin/localedef

cd libc
make RPM_BUILD_ROOT="$RPM_BUILD_ROOT" install

rm -f $RPM_BUILD_ROOT/usr/include/linux $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/asm
ln -sf ../../src/linux/include/linux $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/linux
ln -sf ../../src/linux/include/asm $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/asm

install -m644 nys/nsw/etc/nsswitch.conf $RPM_BUILD_ROOT/etc

cd $RPM_BUILD_ROOT/usr/i486-linuxlibc5/lib
rm -f libc.so libm.so
ln -s libc.so.%{version} libc.so
ln -s libm.so.%{mversion} libm.so
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/ansidecl.h
#rm -f $RPM_BUILD_ROOT/usr/i486-linuxlibc5/include/obstack.h

%clean
if [ "X$RPM_BUILD_ROOT" != "X" ]; then
  rm -rf $RPM_BUILD_ROOT
fi

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%doc libc/README.nys libc/nys/README libc/nys/nis/etc/nis.conf libc/nys/yp/etc/yp.conf
%config /etc/nsswitch.conf
/usr/i486-linuxlibc5/lib/libm.so.%{mversion}
/usr/i486-linuxlibc5/lib/libc.so.%{version}

%files devel
%dir /usr/i486-linuxlibc5/include
%dir /usr/i486-linuxlibc5/include/arpa
%dir /usr/i486-linuxlibc5/include/bsd
%dir /usr/i486-linuxlibc5/include/bsd/sys
%dir /usr/i486-linuxlibc5/include/gnu
%dir /usr/i486-linuxlibc5/include/netinet
%dir /usr/i486-linuxlibc5/include/net
%dir /usr/i486-linuxlibc5/include/i386
%dir /usr/i486-linuxlibc5/include/m68k
%dir /usr/i486-linuxlibc5/include/protocols
%dir /usr/i486-linuxlibc5/include/pthread
%dir /usr/i486-linuxlibc5/include/pthread/mit
%dir /usr/i486-linuxlibc5/include/pthread/mit/sys
%dir /usr/i486-linuxlibc5/include/rpc
%dir /usr/i486-linuxlibc5/include/rpcsvc
%dir /usr/i486-linuxlibc5/include/sys
%dir /usr/i486-linuxlibc5/include/netatalk
/usr/i486-linuxlibc5/lib/crt1.o
/usr/i486-linuxlibc5/lib/crtbegin.o
/usr/i486-linuxlibc5/lib/crtbeginS.o
/usr/i486-linuxlibc5/lib/crtend.o
/usr/i486-linuxlibc5/lib/crtendS.o
/usr/i486-linuxlibc5/lib/crti.o
/usr/i486-linuxlibc5/lib/crtn.o
/usr/i486-linuxlibc5/lib/gcrt1.o
/usr/i486-linuxlibc5/lib/libbsd.a
/usr/i486-linuxlibc5/lib/libgmon.a
/usr/i486-linuxlibc5/lib/libmcheck.a
/usr/i486-linuxlibc5/lib/libc.so
/usr/i486-linuxlibc5/lib/libm.so
/usr/i486-linuxlibc5/include/arpa/ftp.h
/usr/i486-linuxlibc5/include/arpa/inet.h
/usr/i486-linuxlibc5/include/arpa/nameser.h
/usr/i486-linuxlibc5/include/arpa/telnet.h
/usr/i486-linuxlibc5/include/arpa/tftp.h
/usr/i486-linuxlibc5/include/_G_config.h
/usr/i486-linuxlibc5/include/a.out.h
/usr/i486-linuxlibc5/include/alloca.h
/usr/i486-linuxlibc5/include/ansidecl.h
/usr/i486-linuxlibc5/include/ar.h
/usr/i486-linuxlibc5/include/argz.h
/usr/i486-linuxlibc5/include/assert.h
/usr/i486-linuxlibc5/include/bstring.h
/usr/i486-linuxlibc5/include/bytesex.h
/usr/i486-linuxlibc5/include/confname.h
/usr/i486-linuxlibc5/include/confstr.h
/usr/i486-linuxlibc5/include/ctype.h
/usr/i486-linuxlibc5/include/des_crypt.h
/usr/i486-linuxlibc5/include/dirent.h
/usr/i486-linuxlibc5/include/elf.h
/usr/i486-linuxlibc5/include/endian.h
/usr/i486-linuxlibc5/include/err.h
/usr/i486-linuxlibc5/include/errno.h
/usr/i486-linuxlibc5/include/fcntl.h
/usr/i486-linuxlibc5/include/features.h
/usr/i486-linuxlibc5/include/fnmatch.h
/usr/i486-linuxlibc5/include/fpu_control.h
/usr/i486-linuxlibc5/include/ftw.h
/usr/i486-linuxlibc5/include/getopt.h
/usr/i486-linuxlibc5/include/glob.h
/usr/i486-linuxlibc5/include/gmp-mparam.h
/usr/i486-linuxlibc5/include/gnu-stabs.h
/usr/i486-linuxlibc5/include/grp.h
/usr/i486-linuxlibc5/include/huge_val.h
/usr/i486-linuxlibc5/include/ieee754.h
/usr/i486-linuxlibc5/include/ieee854.h
/usr/i486-linuxlibc5/include/jmp_buf.h
/usr/i486-linuxlibc5/include/langinfo.h
/usr/i486-linuxlibc5/include/lastlog.h
/usr/i486-linuxlibc5/include/libelf.h
/usr/i486-linuxlibc5/include/libio.h
/usr/i486-linuxlibc5/include/limits.h
/usr/i486-linuxlibc5/include/link.h
/usr/i486-linuxlibc5/include/locale.h
/usr/i486-linuxlibc5/include/malloc.h
/usr/i486-linuxlibc5/include/math.h
/usr/i486-linuxlibc5/include/memory.h
/usr/i486-linuxlibc5/include/mntent.h
/usr/i486-linuxlibc5/include/nan.h
/usr/i486-linuxlibc5/include/netdb.h
/usr/i486-linuxlibc5/include/nl_types.h
/usr/i486-linuxlibc5/include/nlist.h
/usr/i486-linuxlibc5/include/obstack.h
/usr/i486-linuxlibc5/include/paths.h
/usr/i486-linuxlibc5/include/posix1_lim.h
/usr/i486-linuxlibc5/include/posix2_lim.h
/usr/i486-linuxlibc5/include/posix_opt.h
/usr/i486-linuxlibc5/include/printf.h
/usr/i486-linuxlibc5/include/pthread.h
/usr/i486-linuxlibc5/include/pwd.h
/usr/i486-linuxlibc5/include/rx.h
/usr/i486-linuxlibc5/include/regex.h
/usr/i486-linuxlibc5/include/regexp.h
/usr/i486-linuxlibc5/include/resolv.h
/usr/i486-linuxlibc5/include/rpc.h
/usr/i486-linuxlibc5/include/sched.h
/usr/i486-linuxlibc5/include/search.h
/usr/i486-linuxlibc5/include/setjmp.h
/usr/i486-linuxlibc5/include/shadow.h
/usr/i486-linuxlibc5/include/sharedlib.h
/usr/i486-linuxlibc5/include/signal.h
/usr/i486-linuxlibc5/include/stab.def
/usr/i486-linuxlibc5/include/stab.h
/usr/i486-linuxlibc5/include/stdio.h
/usr/i486-linuxlibc5/include/stdlib.h
/usr/i486-linuxlibc5/include/string.h
/usr/i486-linuxlibc5/include/strings.h
/usr/i486-linuxlibc5/include/syscall.h
/usr/i486-linuxlibc5/include/sysexits.h
/usr/i486-linuxlibc5/include/syslog.h
/usr/i486-linuxlibc5/include/tar.h
/usr/i486-linuxlibc5/include/termio.h
/usr/i486-linuxlibc5/include/termios.h
/usr/i486-linuxlibc5/include/time.h
/usr/i486-linuxlibc5/include/ulimit.h
/usr/i486-linuxlibc5/include/unistd.h
/usr/i486-linuxlibc5/include/utime.h
/usr/i486-linuxlibc5/include/utmp.h
/usr/i486-linuxlibc5/include/values.h
/usr/i486-linuxlibc5/include/wait.h
/usr/i486-linuxlibc5/include/waitflags.h
/usr/i486-linuxlibc5/include/waitstatus.h
/usr/i486-linuxlibc5/include/wchar.h
/usr/i486-linuxlibc5/include/wctype.h
/usr/i486-linuxlibc5/include/bsd/sys/ttychars.h
/usr/i486-linuxlibc5/include/bsd/bsd.h
/usr/i486-linuxlibc5/include/bsd/errno.h
/usr/i486-linuxlibc5/include/bsd/sgtty.h
/usr/i486-linuxlibc5/include/bsd/signal.h
/usr/i486-linuxlibc5/include/bsd/stdlib.h
/usr/i486-linuxlibc5/include/bsd/tzfile.h
/usr/i486-linuxlibc5/include/bsd/unistd.h
/usr/i486-linuxlibc5/include/gnu/types.h
/usr/i486-linuxlibc5/include/i386/fpu_control.h
/usr/i486-linuxlibc5/include/i386/gmp-mparam.h
/usr/i486-linuxlibc5/include/i386/ieeefp.h
/usr/i486-linuxlibc5/include/i386/jmp_buf.h
/usr/i486-linuxlibc5/include/i386/syscall.h
/usr/i486-linuxlibc5/include/m68k/__math.h
/usr/i486-linuxlibc5/include/m68k/fpu_control.h
/usr/i486-linuxlibc5/include/m68k/gmp-mparam.h
/usr/i486-linuxlibc5/include/m68k/ieeefp.h
/usr/i486-linuxlibc5/include/m68k/jmp_buf.h
/usr/i486-linuxlibc5/include/m68k/syscall.h
/usr/i486-linuxlibc5/include/net/if.h
/usr/i486-linuxlibc5/include/net/if_arp.h
/usr/i486-linuxlibc5/include/net/if_route.h
/usr/i486-linuxlibc5/include/net/ppp-comp.h
/usr/i486-linuxlibc5/include/net/ppp_defs.h
/usr/i486-linuxlibc5/include/net/route.h
/usr/i486-linuxlibc5/include/netinet/igmp.h
/usr/i486-linuxlibc5/include/netinet/in.h
/usr/i486-linuxlibc5/include/netinet/in_systm.h
/usr/i486-linuxlibc5/include/netinet/ip.h
/usr/i486-linuxlibc5/include/netinet/ip_fw.h
/usr/i486-linuxlibc5/include/netinet/ip_icmp.h
/usr/i486-linuxlibc5/include/netinet/ip_mroute.h
/usr/i486-linuxlibc5/include/netinet/ip_tcp.h
/usr/i486-linuxlibc5/include/netinet/ip_udp.h
/usr/i486-linuxlibc5/include/netinet/protocols.h
/usr/i486-linuxlibc5/include/netinet/tcp.h
/usr/i486-linuxlibc5/include/netinet/udp.h
/usr/i486-linuxlibc5/include/protocols/routed.h
/usr/i486-linuxlibc5/include/protocols/rwhod.h
/usr/i486-linuxlibc5/include/protocols/talkd.h
/usr/i486-linuxlibc5/include/protocols/timed.h
/usr/i486-linuxlibc5/include/pthread/mit/sys/compat.h
/usr/i486-linuxlibc5/include/pthread/mit/sys/timers.h
/usr/i486-linuxlibc5/include/pthread/mit/sys/types.h
/usr/i486-linuxlibc5/include/pthread/mit/cleanup.h
/usr/i486-linuxlibc5/include/pthread/mit/cond.h
/usr/i486-linuxlibc5/include/pthread/mit/debug_out.h
/usr/i486-linuxlibc5/include/pthread/mit/fd.h
/usr/i486-linuxlibc5/include/pthread/mit/fd_pipe.h
/usr/i486-linuxlibc5/include/pthread/mit/kernel.h
/usr/i486-linuxlibc5/include/pthread/mit/kthread.h
/usr/i486-linuxlibc5/include/pthread/mit/machdep.h
/usr/i486-linuxlibc5/include/pthread/mit/mutex.h
/usr/i486-linuxlibc5/include/pthread/mit/posix.h
/usr/i486-linuxlibc5/include/pthread/mit/prio_queue.h
/usr/i486-linuxlibc5/include/pthread/mit/pthread.h
/usr/i486-linuxlibc5/include/pthread/mit/pthread_attr.h
/usr/i486-linuxlibc5/include/pthread/mit/pthread_once.h
/usr/i486-linuxlibc5/include/pthread/mit/queue.h
/usr/i486-linuxlibc5/include/pthread/mit/sleep.h
/usr/i486-linuxlibc5/include/pthread/mit/specific.h
/usr/i486-linuxlibc5/include/pthread/mit/state.def
/usr/i486-linuxlibc5/include/pthread/mit/types.h
/usr/i486-linuxlibc5/include/pthread/mit/unistd.h
/usr/i486-linuxlibc5/include/pthread/mit/util.h
/usr/i486-linuxlibc5/include/pthread/mit/version.h
/usr/i486-linuxlibc5/include/pthread/mit/xtypes.h
/usr/i486-linuxlibc5/include/rpc/auth.h
/usr/i486-linuxlibc5/include/rpc/auth_des.h
/usr/i486-linuxlibc5/include/rpc/auth_unix.h
/usr/i486-linuxlibc5/include/rpc/clnt.h
/usr/i486-linuxlibc5/include/rpc/key_prot.h
/usr/i486-linuxlibc5/include/rpc/key_prot.x
/usr/i486-linuxlibc5/include/rpc/pmap_clnt.h
/usr/i486-linuxlibc5/include/rpc/pmap_prot.h
/usr/i486-linuxlibc5/include/rpc/pmap_rmt.h
/usr/i486-linuxlibc5/include/rpc/rpc.h
/usr/i486-linuxlibc5/include/rpc/rpc_msg.h
/usr/i486-linuxlibc5/include/rpc/svc.h
/usr/i486-linuxlibc5/include/rpc/svc_auth.h
/usr/i486-linuxlibc5/include/rpc/types.h
/usr/i486-linuxlibc5/include/rpc/xdr.h
/usr/i486-linuxlibc5/include/rpcsvc/bootparam_prot
/usr/i486-linuxlibc5/include/rpcsvc/bootparam_prot.x
/usr/i486-linuxlibc5/include/rpcsvc/klm_prot.h
/usr/i486-linuxlibc5/include/rpcsvc/klm_prot.x
/usr/i486-linuxlibc5/include/rpcsvc/mount.h
/usr/i486-linuxlibc5/include/rpcsvc/mount.x
/usr/i486-linuxlibc5/include/rpcsvc/nfs_prot.h
/usr/i486-linuxlibc5/include/rpcsvc/nfs_prot.x
/usr/i486-linuxlibc5/include/rpcsvc/nlm_prot.h
/usr/i486-linuxlibc5/include/rpcsvc/nlm_prot.x
/usr/i486-linuxlibc5/include/rpcsvc/rex.h
/usr/i486-linuxlibc5/include/rpcsvc/rex.x
/usr/i486-linuxlibc5/include/rpcsvc/rquota.h
/usr/i486-linuxlibc5/include/rpcsvc/rquota.x
/usr/i486-linuxlibc5/include/rpcsvc/rstat.h
/usr/i486-linuxlibc5/include/rpcsvc/rstat.x
/usr/i486-linuxlibc5/include/rpcsvc/rusers.h
/usr/i486-linuxlibc5/include/rpcsvc/rusers.x
/usr/i486-linuxlibc5/include/rpcsvc/sm_inter.h
/usr/i486-linuxlibc5/include/rpcsvc/sm_inter.x
/usr/i486-linuxlibc5/include/rpcsvc/spray.h
/usr/i486-linuxlibc5/include/rpcsvc/spray.x
/usr/i486-linuxlibc5/include/rpcsvc/yp.x
/usr/i486-linuxlibc5/include/rpcsvc/yp_prot.h
/usr/i486-linuxlibc5/include/rpcsvc/ypclnt.h
/usr/i486-linuxlibc5/include/rpcsvc/yppasswd.x
/usr/i486-linuxlibc5/include/rpcsvc/ypupdate_prot.h
/usr/i486-linuxlibc5/include/rpcsvc/ypupdate_prot.x
/usr/i486-linuxlibc5/include/rpcsvc/yp.h
/usr/i486-linuxlibc5/include/rpcsvc/yppasswd.h
/usr/i486-linuxlibc5/include/sys/acct.h
/usr/i486-linuxlibc5/include/sys/bitypes.h
/usr/i486-linuxlibc5/include/sys/cdefs.h
/usr/i486-linuxlibc5/include/sys/debugreg.h
/usr/i486-linuxlibc5/include/sys/dir.h
/usr/i486-linuxlibc5/include/sys/dirent.h
/usr/i486-linuxlibc5/include/sys/errno.h
/usr/i486-linuxlibc5/include/sys/fcntl.h
/usr/i486-linuxlibc5/include/sys/file.h
/usr/i486-linuxlibc5/include/sys/ioctl.h
/usr/i486-linuxlibc5/include/sys/ipc.h
/usr/i486-linuxlibc5/include/sys/kd.h
/usr/i486-linuxlibc5/include/sys/mman.h
/usr/i486-linuxlibc5/include/sys/mount.h
/usr/i486-linuxlibc5/include/sys/msg.h
/usr/i486-linuxlibc5/include/sys/mtio.h
/usr/i486-linuxlibc5/include/sys/param.h
/usr/i486-linuxlibc5/include/sys/procfs.h
/usr/i486-linuxlibc5/include/sys/ptrace.h
/usr/i486-linuxlibc5/include/sys/queue.h
/usr/i486-linuxlibc5/include/sys/resource.h
/usr/i486-linuxlibc5/include/sys/sem.h
/usr/i486-linuxlibc5/include/sys/serial.h
/usr/i486-linuxlibc5/include/sys/shm.h
/usr/i486-linuxlibc5/include/sys/signal.h
/usr/i486-linuxlibc5/include/sys/socket.h
/usr/i486-linuxlibc5/include/sys/socketcall.h
/usr/i486-linuxlibc5/include/sys/socketio.h
/usr/i486-linuxlibc5/include/sys/socketvar.h
/usr/i486-linuxlibc5/include/sys/soundcard.h
/usr/i486-linuxlibc5/include/sys/stat.h
/usr/i486-linuxlibc5/include/sys/syscall.h
/usr/i486-linuxlibc5/include/sys/sysctl.h
/usr/i486-linuxlibc5/include/sys/sysinfo.h
/usr/i486-linuxlibc5/include/sys/syslog.h
/usr/i486-linuxlibc5/include/sys/sysmacros.h
/usr/i486-linuxlibc5/include/sys/termio.h
/usr/i486-linuxlibc5/include/sys/termios.h
/usr/i486-linuxlibc5/include/sys/time.h
/usr/i486-linuxlibc5/include/sys/timeb.h
/usr/i486-linuxlibc5/include/sys/times.h
/usr/i486-linuxlibc5/include/sys/timex.h
/usr/i486-linuxlibc5/include/sys/tty.h
/usr/i486-linuxlibc5/include/sys/types.h
/usr/i486-linuxlibc5/include/sys/uio.h
/usr/i486-linuxlibc5/include/sys/ultrasound.h
/usr/i486-linuxlibc5/include/sys/un.h
/usr/i486-linuxlibc5/include/sys/user.h
/usr/i486-linuxlibc5/include/sys/utsname.h
/usr/i486-linuxlibc5/include/sys/varargs.h
/usr/i486-linuxlibc5/include/sys/vfs.h
/usr/i486-linuxlibc5/include/sys/vm86.h
/usr/i486-linuxlibc5/include/sys/vt.h
/usr/i486-linuxlibc5/include/sys/wait.h
/usr/i486-linuxlibc5/include/sys/poll.h
/usr/i486-linuxlibc5/include/sys/quota.h
/usr/i486-linuxlibc5/include/netatalk/at.h
/usr/i486-linuxlibc5/include/linux
/usr/i486-linuxlibc5/include/asm

%files static
/usr/i486-linuxlibc5/lib/libc.a
/usr/i486-linuxlibc5/lib/libm.a

%files profile
/usr/i486-linuxlibc5/lib/libc_p.a

%files debug
/usr/i486-linuxlibc5/lib/libg.a

#%files locale
#/usr/i486-linuxlibc5/bin/locale
#/usr/i486-linuxlibc5/bin/localedef
